* ftparchive/multicompress.cc, apt-inst/deb/debfile.cc:
[ntk/apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 # we all like colorful messages
4 CERROR="\e[1;31m" # red
5 CWARNING="\e[1;33m" # yellow
6 CMSG="\e[1;32m" # green
7 CINFO="\e[1;96m" # light blue
8 CDEBUG="\e[1;94m" # blue
9 CNORMAL="\e[0;39m" # default system console color
10 CDONE="\e[1;32m" # green
11 CPASS="\e[1;32m" # green
12 CFAIL="\e[1;31m" # red
13 CCMD="\e[1;35m" # pink
14
15 msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30 # enable / disable Debugging
31 MSGLEVEL=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34 fi
35 if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38 fi
39 if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
46 fi
47 if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50 fi
51 if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54 fi
55 msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65 }
66
67 runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
76 }
77 aptconfig() { runapt apt-config $*; }
78 aptcache() { runapt apt-cache $*; }
79 aptget() { runapt apt-get $*; }
80 aptftparchive() { runapt apt-ftparchive $*; }
81 aptkey() { runapt apt-key $*; }
82 aptmark() { runapt apt-mark $*; }
83 dpkg() {
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
85 }
86 aptitude() {
87 if [ -f ./aptconfig.conf ]; then
88 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
89 elif [ -f ../aptconfig.conf ]; then
90 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
91 else
92 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
93 fi
94 }
95
96 addtrap() {
97 CURRENTTRAP="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
99 }
100
101 setupenvironment() {
102 TMPWORKINGDIRECTORY=$(mktemp -d)
103 local TESTDIR=$(readlink -f $(dirname $0))
104 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}"
105 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
107 local OLDWORKINGDIRECTORY=$(pwd)
108 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
109 cd $TMPWORKINGDIRECTORY
110 mkdir rootdir aptarchive keys
111 cd rootdir
112 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
113 mkdir -p var/cache var/lib var/log
114 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
115 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
118 else
119 touch var/lib/dpkg/status
120 fi
121 touch var/lib/dpkg/available
122 mkdir -p usr/lib/apt
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
124 cd ..
125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
128 fi
129 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
132 fi
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
135 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
136 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
137 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
138 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
139 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
140 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
141 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
146 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
147 export LC_ALL=C
148 msgdone "info"
149 }
150
151 configarchitecture() {
152 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
153 echo "APT::Architecture \"$1\";" > $CONFFILE
154 shift
155 while [ -n "$1" ]; do
156 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
157 shift
158 done
159 }
160
161 setupsimplenativepackage() {
162 local NAME="$1"
163 local ARCH="$2"
164 local VERSION="$3"
165 local RELEASE="${4:-unstable}"
166 local DEPENDENCIES="$5"
167 local DESCRIPTION="$6"
168 local SECTION="${7:-others}"
169 local DISTSECTION
170 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
171 DISTSECTION="main"
172 else
173 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
174 fi
175 local BUILDDIR=incoming/${NAME}-${VERSION}
176 mkdir -p ${BUILDDIR}/debian/source
177 cd ${BUILDDIR}
178 echo "* most suckless software product ever" > FEATURES
179 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
180 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
181
182 * Initial release
183
184 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
185 test -e debian/control || echo "Source: $NAME
186 Section: $SECTION
187 Priority: optional
188 Maintainer: Joe Sixpack <joe@example.org>
189 Build-Depends: debhelper (>= 7)
190 Standards-Version: 3.9.1
191
192 Package: $NAME" > debian/control
193 if [ "$ARCH" = 'all' ]; then
194 echo "Architecture: all" >> debian/control
195 else
196 echo "Architecture: any" >> debian/control
197 fi
198 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
199 if [ -z "$DESCRIPTION" ]; then
200 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
201 If you find such a package installed on your system,
202 YOU did something horribly wrong! They are autogenerated
203 und used only by testcases for APT and surf no other propose…" >> debian/control
204 else
205 echo "Description: $DESCRIPTION" >> debian/control
206 fi
207 test -e debian/compat || echo "7" > debian/compat
208 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
209 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
210 cd - > /dev/null
211 }
212
213 buildsimplenativepackage() {
214 local NAME="$1"
215 local ARCH="$2"
216 local VERSION="$3"
217 local RELEASE="${4:-unstable}"
218 local DEPENDENCIES="$5"
219 local DESCRIPTION="$6"
220 local SECTION="${7:-others}"
221 local DISTSECTION
222 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
223 DISTSECTION="main"
224 else
225 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
226 fi
227 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
228
229 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}"
230 mkdir -p $BUILDDIR/debian/source
231 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
232 echo "#!/bin/sh
233 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
234
235 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
236 echo "$NAME ($VERSION) $RELEASE; urgency=low
237
238 * Initial release
239
240 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
241 echo "Source: $NAME
242 Section: $SECTION
243 Priority: optional
244 Maintainer: Joe Sixpack <joe@example.org>
245 Standards-Version: 3.9.1
246
247 Package: $NAME" > ${BUILDDIR}/debian/control
248 if [ "$ARCH" = 'all' ]; then
249 echo "Architecture: all" >> ${BUILDDIR}/debian/control
250 else
251 echo "Architecture: any" >> ${BUILDDIR}/debian/control
252 fi
253 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
254 if [ -z "$DESCRIPTION" ]; then
255 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
256 If you find such a package installed on your system,
257 YOU did something horribly wrong! They are autogenerated
258 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
259 else
260 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
261 fi
262 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
263 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
264
265 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
266 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
267 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
268 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$ARCH)
269 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
270
271 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
272 echo "pool/${NAME}_${VERSION}_${ARCH}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
273 for SRC in $SRCS; do
274 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
275 done
276 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
277 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
278 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
279 rm -rf "${BUILDDIR}"
280 msgdone "info"
281 }
282
283 buildpackage() {
284 local BUILDDIR=$1
285 local RELEASE=$2
286 local SECTION=$3
287 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}"
288 cd $BUILDDIR
289 if [ "$ARCH" = "all" ]; then
290 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
291 fi
292 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
293 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
294 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
295 cd - > /dev/null
296 for PKG in $PKGS; do
297 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
298 done
299 for SRC in $SRCS; do
300 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
301 done
302 msgdone "info"
303 }
304
305 buildaptarchive() {
306 if [ -d incoming ]; then
307 buildaptarchivefromincoming $*
308 else
309 buildaptarchivefromfiles $*
310 fi
311 }
312
313 createaptftparchiveconfig() {
314 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
315 if [ -z "$ARCHS" ]; then
316 # the pool is empty, so we will operate on faked packages - let us use the configured archs
317 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
318 fi
319 echo -n 'Dir {
320 ArchiveDir "' >> ftparchive.conf
321 echo -n $(readlink -f .) >> ftparchive.conf
322 echo -n '";
323 CacheDir "' >> ftparchive.conf
324 echo -n $(readlink -f ..) >> ftparchive.conf
325 echo -n '";
326 FileListDir "' >> ftparchive.conf
327 echo -n $(readlink -f pool/) >> ftparchive.conf
328 echo -n '";
329 };
330 Default {
331 Packages::Compress ". gzip bzip2 lzma xz";
332 Sources::Compress ". gzip bzip2 lzma xz";
333 Contents::Compress ". gzip bzip2 lzma xz";
334 Translation::Compress ". gzip bzip2 lzma xz";
335 LongDescription "false";
336 };
337 TreeDefault {
338 Directory "pool/";
339 SrcDirectory "pool/";
340 };
341 APT {
342 FTPArchive {
343 Release {
344 Origin "joesixpack";
345 Label "apttestcases";
346 Suite "unstable";
347 Description "repository with dummy packages";
348 Architectures "' >> ftparchive.conf
349 echo -n "$ARCHS" >> ftparchive.conf
350 echo 'source";
351 };
352 };
353 };' >> ftparchive.conf
354 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
355 echo -n 'tree "dists/' >> ftparchive.conf
356 echo -n "$DIST" >> ftparchive.conf
357 echo -n '" {
358 Architectures "' >> ftparchive.conf
359 echo -n "$ARCHS" >> ftparchive.conf
360 echo -n 'source";
361 FileList "' >> ftparchive.conf
362 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
363 echo -n '";
364 SourceFileList "' >> ftparchive.conf
365 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
366 echo -n '";
367 Sections "' >> ftparchive.conf
368 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
369 echo '";
370 };' >> ftparchive.conf
371 done
372 }
373
374 buildaptftparchivedirectorystructure() {
375 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
376 for DIST in $DISTS; do
377 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
378 for SECTION in $SECTIONS; do
379 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
380 for ARCH in $ARCHS; do
381 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
382 done
383 mkdir -p dists/${DIST}/${SECTION}/source
384 mkdir -p dists/${DIST}/${SECTION}/i18n
385 done
386 done
387 }
388
389 insertpackage() {
390 local RELEASE="$1"
391 local NAME="$2"
392 local ARCH="$3"
393 local VERSION="$4"
394 local DEPENDENCIES="$5"
395 local ARCHS="$ARCH"
396 if [ "$ARCHS" = "all" ]; then
397 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
398 fi
399 for BUILDARCH in $ARCHS; do
400 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
401 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
402 touch aptarchive/dists/${RELEASE}/main/source/Sources
403 local FILE="${PPATH}/Packages"
404 echo "Package: $NAME
405 Priority: optional
406 Section: other
407 Installed-Size: 42
408 Maintainer: Joe Sixpack <joe@example.org>
409 Architecture: $ARCH
410 Version: $VERSION
411 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
412 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
413 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
414 If you find such a package installed on your system,
415 YOU did something horribly wrong! They are autogenerated
416 und used only by testcases for APT and surf no other propose…
417 " >> $FILE
418 done
419 }
420
421 buildaptarchivefromincoming() {
422 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
423 cd aptarchive
424 [ -e pool ] || ln -s ../incoming pool
425 [ -e ftparchive.conf ] || createaptftparchiveconfig
426 [ -e dists ] || buildaptftparchivedirectorystructure
427 msgninfo "\tGenerate Packages, Sources and Contents files… "
428 aptftparchive -qq generate ftparchive.conf
429 cd - > /dev/null
430 msgdone "info"
431 generatereleasefiles
432 }
433
434 buildaptarchivefromfiles() {
435 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
436 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
437 msgninfo "\t${line} file"
438 cat ${line} | gzip > ${line}.gz
439 cat ${line} | bzip2 > ${line}.bz2
440 cat ${line} | lzma > ${line}.lzma
441 cat ${line} | xz > ${line}.xz
442 msgdone "info"
443 done
444 generatereleasefiles
445 }
446
447 generatereleasefiles() {
448 msgninfo "\tGenerate Release files… "
449 local DATE="${1:-now}"
450 if [ -e aptarchive/dists ]; then
451 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
452 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
453 done
454 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
455 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
456 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
457 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
458 sed -i '/^Date: / a\
459 NotAutomatic: yes' $dir/Release
460 fi
461 done
462 else
463 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
464 fi
465 if [ "$DATE" != "now" ]; then
466 for release in $(find ./aptarchive -name 'Release'); do
467 touch -d "$1" $release
468 done
469 fi
470 msgdone "info"
471 }
472
473 setupdistsaptarchive() {
474 local APTARCHIVE=$(readlink -f ./aptarchive)
475 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
476 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
477 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
478 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
479 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}"
480 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
481 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
482 msgdone "info"
483 done
484 }
485
486 setupflataptarchive() {
487 local APTARCHIVE=$(readlink -f ./aptarchive)
488 if [ -f ${APTARCHIVE}/Packages ]; then
489 msgninfo "\tadd deb sources.list line… "
490 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
491 msgdone "info"
492 else
493 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
494 fi
495 if [ -f ${APTARCHIVE}/Sources ]; then
496 msgninfo "\tadd deb-src sources.list line… "
497 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
498 msgdone "info"
499 else
500 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
501 fi
502 }
503
504 setupaptarchive() {
505 buildaptarchive
506 if [ -e aptarchive/dists ]; then
507 setupdistsaptarchive
508 else
509 setupflataptarchive
510 fi
511 signreleasefiles
512 msgninfo "\tSync APT's cache with the archive… "
513 aptget update -qq
514 msgdone "info"
515 }
516
517 signreleasefiles() {
518 local SIGNER="${1:-Joe Sixpack}"
519 msgninfo "\tSign archive with $SIGNER key… "
520 local SECKEYS=""
521 for KEY in $(find keys/ -name '*.sec'); do
522 SECKEYS="$SECKEYS --secret-keyring $KEY"
523 done
524 local PUBKEYS=""
525 for KEY in $(find keys/ -name '*.pub'); do
526 PUBKEYS="$PUBKEYS --keyring $KEY"
527 done
528 for RELEASE in $(find aptarchive/ -name Release); do
529 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
530 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
531 done
532 msgdone "info"
533 }
534
535 changetowebserver() {
536 if which weborf > /dev/null; then
537 weborf -xb aptarchive/ 2>&1 > /dev/null &
538 addtrap "kill $!;"
539 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
540 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
541 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
542 done
543 return 0
544 fi
545 return 1
546 }
547
548 checkdiff() {
549 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
550 if [ -n "$DIFFTEXT" ]; then
551 echo
552 echo "$DIFFTEXT"
553 return 1
554 else
555 return 0
556 fi
557 }
558
559 testfileequal() {
560 local FILE="$1"
561 shift
562 msgtest "Test for correctness of file" "$FILE"
563 if [ -z "$*" ]; then
564 echo -n "" | checkdiff $FILE - && msgpass || msgfail
565 else
566 echo "$*" | checkdiff $FILE - && msgpass || msgfail
567 fi
568 }
569
570 testequal() {
571 local COMPAREFILE=$(mktemp)
572 addtrap "rm $COMPAREFILE;"
573 echo "$1" > $COMPAREFILE
574 shift
575 msgtest "Test for equality of" "$*"
576 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
577 }
578
579 testequalor2() {
580 local COMPAREFILE1=$(mktemp)
581 local COMPAREFILE2=$(mktemp)
582 local COMPAREAGAINST=$(mktemp)
583 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
584 echo "$1" > $COMPAREFILE1
585 echo "$2" > $COMPAREFILE2
586 shift 2
587 msgtest "Test for equality OR of" "$*"
588 $* 2>&1 1> $COMPAREAGAINST
589 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
590 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
591 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
592 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
593 msgfail )
594 }
595
596 testshowvirtual() {
597 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
598 local PACKAGE="$1"
599 shift
600 while [ -n "$1" ]; do
601 VIRTUAL="${VIRTUAL}
602 N: Can't select versions from package '$1' as it is purely virtual"
603 PACKAGE="${PACKAGE} $1"
604 shift
605 done
606 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
607 VIRTUAL="${VIRTUAL}
608 N: No packages found"
609 local COMPAREFILE=$(mktemp)
610 addtrap "rm $COMPAREFILE;"
611 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
612 eval `apt-config shell ARCH APT::Architecture`
613 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
614 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
615 }
616
617 testnopackage() {
618 msgtest "Test for non-existent packages" "apt-cache show $*"
619 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
620 if [ -n "$SHOWPKG" ]; then
621 echo
622 echo "$SHOWPKG"
623 msgfail
624 return 1
625 fi
626 msgpass
627 }
628
629 testdpkginstalled() {
630 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
631 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
632 if [ "$PKGS" != $# ]; then
633 echo $PKGS
634 dpkg -l $* | grep '^[a-z]'
635 msgfail
636 return 1
637 fi
638 msgpass
639 }
640
641 testdpkgnotinstalled() {
642 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
643 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
644 if [ "$PKGS" != 0 ]; then
645 echo
646 dpkg -l $* | grep '^[a-z]'
647 msgfail
648 return 1
649 fi
650 msgpass
651 }
652
653 testmarkedauto() {
654 local COMPAREFILE=$(mktemp)
655 addtrap "rm $COMPAREFILE;"
656 if [ -n "$1" ]; then
657 msgtest 'Test for correctly marked as auto-installed' "$*"
658 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
659 else
660 msgtest 'Test for correctly marked as auto-installed' 'no package'
661 echo > $COMPAREFILE
662 fi
663 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
664 }